SystemOrganization addCategory: #'JQWidgetBox-Dev-Tests'!
SystemOrganization addCategory: #'JQWidgetBox-Dev-Examples'!
SystemOrganization addCategory: #'JQWidgetBox-Dev-Libraries'!

JQUiWelcomeFunctionalTest subclass: #JQWbWelcomeFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-Dev-Tests'!

!JQWbWelcomeFunctionalTest methodsFor: 'as yet unclassified' stamp: 'GastonDallOglio 4/5/2012 14:56'!
renderContentOn: html
	super renderContentOn: html.
	self renderQueryPluginsOn: html! !

!JQWbWelcomeFunctionalTest methodsFor: 'as yet unclassified' stamp: 'GastonDallOglio 4/5/2012 14:49'!
renderQueryPluginsOn: html
	"Text copy from http://docs.jquery.com/Plugins/Authoring"
	html heading level: 4; with: 'jQuery Plugins'.
	html paragraph: [
		html text: 'Extending jQuery with plugins and methods is very powerful and can save you and your peers a lot of development time by abstracting your most clever functions into '.
		html anchor
			url: 'http://plugins.jquery.com/';
			with: 'jQuery Plugins' ]! !

!JQWbWelcomeFunctionalTest methodsFor: 'as yet unclassified' stamp: 'GastonDallOglio 4/5/2012 14:58'!
renderWelcomeOn: html
	html paragraph: [
		html anchor
			url: 'http://www.seaside.st/';
			with: 'Seaside'.
		html text: ' provides a complete integration of '.
		html anchor
			url: 'http://www.jquery.com/';
			with: 'jQuery'.
		html text: ', '.
		html anchor
			url: 'http://ui.jquery.com/';
			with: 'jQuery UI'.
		html text: ' and '.	
		html anchor
			url: 'http://plugins.jquery.com/';
			with: 'jQuery Plugins,'.
		html text: ', allowing the use of these libraries without having to write a single line of JavaScript code. Everything can be configured and plugged together using Smalltalk objects. Try by yourself, by clicking through this functional test suite and by browsing the source-code.' ]! !

WAFileLibrary subclass: #JQWidgetBoxDevelopmentLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-Dev-Libraries'!

JQUiFunctionalTest subclass: #JQWidgetExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-Dev-Examples'!

!JQWidgetExample commentStamp: 'tbn 11/2/2009 14:33' prior: 0!
This is a superclass to group example classes for jquery widget
wrappers for seaside.  

If you add a subclass you have to override #shortName and
after evaluating

   JQWidgetExample initialize

your example is registered!

!JQWidgetExample class methodsFor: 'testing' stamp: 'tbn 11/2/2009 14:29'!
canBeRoot
	"This is not a root, but subclasses can"
	
	^self name ~= #JQWidgetExample! !

!JQWidgetExample class methodsFor: 'class initialization' stamp: 'tbn 2/18/2011 14:35'!
initialize
 	"Either subclasses provide own initialization/registration, otherwise register them"
	self subclasses do: 
		[ :each | 
			(each class selectors includes: #initialize) 
				ifTrue: [each perform: #initialize]
				ifFalse: [ self registerExample: each ]]! !

!JQWidgetExample class methodsFor: 'registration' stamp: 'tbn 2/18/2011 14:41'!
registerExample: exampleClass 
	"Use generic registration for examples"
		
	|application|
	application := WAAdmin register: exampleClass asApplicationAt: 'jquery-widgets/' , exampleClass shortName.
	application addLibrary: JQDeploymentLibrary;
				    addLibrary: JQUiDeploymentLibrary;
				    addLibrary: JQWidgetBoxDeploymentLibrary! !

!JQWidgetExample class methodsFor: 'accessing' stamp: 'tbn 11/2/2009 14:27'!
shortName
	^self subclassResponsibility! !

!JQWidgetExample methodsFor: 'accessing' stamp: 'tbn 11/2/2009 17:07'!
library
	^ JQWidgetBoxDeploymentLibrary! !

!JQWidgetExample methodsFor: 'as yet unclassified' stamp: 'GastonDallOglio 4/5/2012 16:21'!
selectors
	^ #(renderContentOn:)! !

JQueryUiTest subclass: #JQWidgetBoxWidgetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-Dev-Tests'!

!JQWidgetBoxWidgetTest commentStamp: 'tbn 11/2/2009 14:24' prior: 0!
This is a common superclass for tests testing jquery widget wrappers for seaside!

!JQWidgetBoxWidgetTest class methodsFor: 'testing' stamp: 'tbn 11/2/2009 15:46'!
isAbstract
	"Return true, but false for subclasses"
	
	^self name = #JQWidgetBoxWidgetTest! !

JQUiAllFunctionalTests subclass: #JQWbAllFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-Dev-Tests'!

!JQWbAllFunctionalTest class methodsFor: 'accessing' stamp: 'GastonDallOglio 4/5/2012 14:59'!
description
	^ 'jQuery WidgetBox Functional Test Suite'! !

!JQWbAllFunctionalTest class methodsFor: 'initialization' stamp: 'GastonDallOglio 4/5/2012 14:59'!
initialize
	| application |
	application := WAAdmin register: self asApplicationAt: 'javascript/jquery-widgetbox'.
	application preferenceAt: #scriptGeneratorClass put: JQScriptGenerator.
	application
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQWidgetBoxDeploymentLibrary! !

!JQWbAllFunctionalTest methodsFor: 'as yet unclassified' stamp: 'GastonDallOglio 4/5/2012 14:54'!
default
	^ JQWbWelcomeFunctionalTest new! !

!JQWbAllFunctionalTest methodsFor: 'as yet unclassified' stamp: 'GastonDallOglio 4/5/2012 14:21'!
menu
	^ #(('http://www.seaside.st/' 'Seaside') ('http://jquery.com/' 'jQuery') ('http://ui.jquery.com/' 'jQuery UI') ('http://plugins.jquery.com/' 'jQuery Plugins') ('http://docs.jquery.com/Plugins/Authoring' 'Documentation'))! !

!JQWbAllFunctionalTest methodsFor: 'as yet unclassified' stamp: 'GastonDallOglio 4/5/2012 15:58'!
tests
	"Project types copy from http://archive.plugins.jquery.com/"
	^ OrderedCollection new
		add: 'All Plugins' -> (JQWidgetExample allSubclasses collect: [ :c | | i |
			i := c new. i title -> i]);
		add: 'Ajax' -> #();
		add: 'Animation and Effect' -> #();
		add: 'Browser Tweaks' -> #();
		add: 'Data' -> (OrderedCollection new
			add: 'Alpha Numeric Example' -> JQAlphaNumericExample new;
			yourself);
		add: 'DOM' -> #();
		add: 'Drag-and-Drop' -> #();
		add: 'Events' -> #();
		add: 'Forms' -> #();
		add: 'Integration' -> #();
		add: 'JavaScript' -> #();
		add: 'jQuery Extensions' -> #();
		add: 'Layout' -> #();
		add: 'Media' -> #();
		add: 'Menus' -> #();
		add: 'Metaplugin' -> #();
		add: 'Navigation' -> #();
		add: 'Tables' -> #();
		add: 'User Interface' -> #();
		add: 'Utilities' -> #();
		add: 'Widgets' -> #();
		add: 'Windows and Overlays' -> #();
		yourself.! !

!JQWbAllFunctionalTest methodsFor: 'as yet unclassified' stamp: 'GastonDallOglio 4/5/2012 12:29'!
title
	^ 'jQuery Plugin Wrappers for Seaside'! !

!JQWbAllFunctionalTest methodsFor: 'as yet unclassified' stamp: 'GastonDallOglio 4/5/2012 12:31'!
url
	^ 'http://plugins.jquery.com/'! !
JQWidgetExample initialize!
JQWbAllFunctionalTest initialize!
